language: c

_anchors:
  envs:
    - &tiny-nogui
      BUILD=yes TEST=test FEATURES=tiny CONFOPT="--disable-gui" SHADOWOPT= SRCDIR=./src CHECK_AUTOCONF=no
    - &tiny
      BUILD=yes TEST=test FEATURES=tiny CONFOPT= SHADOWOPT= SRCDIR=./src CHECK_AUTOCONF=no
    - &small
      BUILD=yes TEST=test FEATURES=small CONFOPT= SHADOWOPT= SRCDIR=./src CHECK_AUTOCONF=no
    - &normal
      BUILD=yes TEST=test FEATURES=normal CONFOPT= SHADOWOPT= SRCDIR=./src CHECK_AUTOCONF=no
    - &linux-huge
      BUILD=yes TEST="scripttests test_libvterm" CFLAGS="--coverage -DUSE_GCOV_FLUSH" LDFLAGS=--coverage FEATURES=huge SHADOWOPT= SRCDIR=./src CHECK_AUTOCONF=no
      CONFOPT="--enable-perlinterp --enable-pythoninterp --enable-python3interp --enable-rubyinterp --enable-luainterp --enable-tclinterp"
    - &osx-huge # macOS build
      BUILD=yes TEST=test FEATURES=huge SHADOWOPT= SRCDIR=./src CHECK_AUTOCONF=no
      CONFOPT="--enable-perlinterp --enable-pythoninterp --enable-rubyinterp --enable-luainterp --enable-tclinterp"
    - &unittests
      BUILD=no TEST=unittests CFLAGS="--coverage -DUSE_GCOV_FLUSH" LDFLAGS=--coverage FEATURES=huge SHADOWOPT= SRCDIR=./src CHECK_AUTOCONF=yes
    - &asan # ASAN build
      SANITIZER_CFLAGS="-g -O1 -DABORT_ON_INTERNAL_ERROR -DEXITFREE -fsanitize=address -fno-omit-frame-pointer"
      ASAN_OPTIONS="print_stacktrace=1 log_path=asan" LSAN_OPTIONS="suppressions=$TRAVIS_BUILD_DIR/src/testdir/lsan-suppress.txt"
    - &shadowopt
      SHADOWOPT="-C src/shadow" SRCDIR=./src/shadow

  linux: &linux
    os: linux
    dist: bionic
    addons:
      apt:
        packages:
          - autoconf
          - clang
          - lcov
          - gettext
          - libcanberra-dev
          - libperl-dev
          - python-dev
          - python3-dev
          - liblua5.3-dev
          - lua5.3
          - ruby-dev
          - tcl-dev
          - cscope
          - libgtk2.0-dev
          - desktop-file-utils
          - libtool-bin
    services:
      - xvfb
    before_install:
      - rvm reset
      # Use llvm-cov instead of gcov when compiler is clang.
      - |
        if [[ "${CC}" = "clang" ]]; then
          ln -sf "$(command -v llvm-cov)" /home/travis/bin/gcov
        fi
      # Setup lua5.3 manually since its package doesn't provide alternative.
      # https://bugs.launchpad.net/ubuntu/+source/lua5.3/+bug/1707212
      - |
        if [[ "${CONFOPT}" =~ luainterp ]]; then
          sudo update-alternatives --install /usr/bin/lua lua /usr/bin/lua5.3 10
        fi
    before_script:
      - sudo sysctl -w net.ipv6.conf.lo.disable_ipv6=0
      - sudo bash ci/load-snd-dummy.sh || true
      - sudo usermod -a -G audio $USER
      - do_test() { sg audio "sg $(id -gn) '$*'"; }

  osx: &osx
    os: osx
    before_script:
      - do_test() { "$@"; }

  homebrew: &osx-homebrew
    addons:
      homebrew:
        packages:
          - lua
        update: true
    cache:
      directories:
        - /usr/local/Homebrew/Library/Homebrew/vendor/
        - /usr/local/Homebrew/Library/Taps/homebrew/homebrew-core/
    before_install:
      - rvm reset
      # Lua is not installed on macOS
      - export LUA_PREFIX=/usr/local

  coverage: &coverage
    # needed for https support for coveralls building cffi only works with gcc,
    # not with clang
    - CC=gcc pip install --user cpp-coveralls pyopenssl ndg-httpsclient pyasn1
    - ~/.local/bin/coveralls -b "${SRCDIR}" -x .xs -e "${SRCDIR}"/if_perl.c -e "${SRCDIR}"/xxd -e "${SRCDIR}"/libvterm --encodings utf-8
    - (cd "${SRCDIR}" && bash <(curl -s https://codecov.io/bash))

  asan_symbolize: &asan_symbolize
    # Update pyenv to fix the error "/opt/pyenv/libexec/pyenv: line 43: cd: asan_symbolize-6.0: Not a directory".
    # https://github.com/pyenv/pyenv/issues/580
    - (cd "${PYENV_ROOT}" && git fetch -p origin && git checkout "$(git rev-list --tags -n1)") &>/dev/null || true
    - find . -type f -name 'asan.*' -size +0 2>/dev/null | xargs grep -l '^==[[:digit:]]*==ERROR:' | xargs -I{} -n1 -t asan_symbolize -l{}

branches:
  except:
    - /^v[0-9]/

script:
  - NPROC=$(getconf _NPROCESSORS_ONLN)
  - set -o errexit
  - echo -e "\\033[33;1mConfiguring Vim\\033[0m" && echo -en "travis_fold:start:configure\\r\\033[0K"
  - |
    if [[ "${CHECK_AUTOCONF}" = "yes" ]] && [[ "${CC}" = "gcc" ]]; then
      make -C src autoconf
    fi
  - |
    if [[ -n "${SHADOWOPT}" ]]; then
      make -C src shadow
    fi
  # "./configure" changes its working directory into "$SRCDIR".
  - ./configure --with-features=${FEATURES} ${CONFOPT} --enable-fail-if-missing
  - echo -en "travis_fold:end:configure\\r\\033[0K"
  - echo -e "\\033[33;1mBuilding Vim\\033[0m" && echo -en "travis_fold:start:build\\r\\033[0K"
  - |
    if [[ "${BUILD}" = "yes" ]]; then
      # Append various warning flags to CFLAGS.
      # BSD sed needs backup extension specified.
      sed -i.bak -f ci/config.mk.sed ${SRCDIR}/auto/config.mk
      if [[ "${TRAVIS_OS_NAME}" = "osx" ]]; then
        # On macOS, the entity of gcc is clang.
        sed -i.bak -f ci/config.mk.clang.sed ${SRCDIR}/auto/config.mk
      else
        sed -i.bak -f ci/config.mk.${CC}.sed ${SRCDIR}/auto/config.mk
      fi
      make ${SHADOWOPT} -j${NPROC}
    fi
  - echo -en "travis_fold:end:build\\r\\033[0K"
  - set +o errexit
  # Show Vim version and also if_xx versions.
  - |
    if [[ "${BUILD}" = "yes" ]]; then
      "${SRCDIR}"/vim --version
      "${SRCDIR}"/vim -u NONE -i NONE --not-a-term -esNX -V1 -S ci/if_ver-1.vim -c quit
      "${SRCDIR}"/vim -u NONE -i NONE --not-a-term -esNX -V1 -S ci/if_ver-2.vim -c quit
    fi
  - echo -e "\\033[33;1mTesting Vim\\033[0m" && echo -en "travis_fold:start:test\\r\\033[0K"
  - do_test make ${SHADOWOPT} ${TEST} && FOLD_MARKER=travis_fold
  - echo -en "${FOLD_MARKER}:end:test\\r\\033[0K"

# Instead of using all environments with both compilers on both systems,
# exclude some builds on mac os x and linux.
# On mac os x "tiny" is always without GUI, use 2 compilers in 2 environments.
# Linux: 2 compilers on some of the environments + gcc on os390
jobs:
  include:
    - <<: *osx
      name: tiny-nogui/clang
      compiler: clang
      env: *tiny-nogui
    - <<: *osx
      name: tiny-nogui/gcc
      compiler: gcc
      env: *tiny-nogui
    - <<: *osx
      <<: *osx-homebrew
      name: huge/clang
      compiler: clang
      env: *osx-huge
    - <<: *osx
      <<: *osx-homebrew
      name: huge/gcc
      compiler: gcc
      env: *osx-huge
    - <<: *linux
      name: tiny-nogui/clang
      compiler: clang
      env: *tiny-nogui
    - <<: *linux
      name: tiny-nogui/gcc
      compiler: gcc
      env: *tiny-nogui
    - <<: *linux
      name: tiny/clang
      compiler: clang
      env: *tiny
    - <<: *linux
      name: tiny/gcc
      compiler: gcc
      env: *tiny
    - <<: *linux
      name: small/gcc
      compiler: gcc
      env: *small
    - <<: *linux
      name: normal/clang
      compiler: clang
      env:
        - *normal
        - *shadowopt
    - <<: *linux
      name: normal/gcc
      compiler: gcc
      env:
        - *normal
        - *shadowopt
    - <<: *linux
      arch: s390x
      name: huge/gcc-s390x
      compiler: gcc
      env: *linux-huge
      services: []
    - <<: *linux
      name: huge+coverage/clang
      compiler: clang
      env:
        - *linux-huge
        # Clang cannot compile test_libvterm with "--coverage" flag.
        - TEST=scripttests
      after_success: *coverage
    - <<: *linux
      name: huge+coverage/gcc
      compiler: gcc
      env: *linux-huge
      after_success: *coverage
    - <<: *linux # ASAN
      name: huge+asan/gcc
      compiler: gcc
      env:
        - *linux-huge
        - *asan
      after_failure: *asan_symbolize
    - <<: *linux
      name: huge-testgui+coverage/gcc
      compiler: gcc
      env:
        - *linux-huge
        - TEST="-C src testgui"
      after_success: *coverage
    - <<: *linux
      name: unittests+coverage/gcc
      compiler: gcc
      env: *unittests
      after_success: *coverage
    - <<: *linux
      name: vimtags/gcc
      compiler: gcc
      env:
        - *normal
        - TEST="-C runtime/doc vimtags VIMEXE=../../${SRCDIR}/vim"

# vim:set sts=2 sw=2 tw=0 et:
